#649 (Div. 2)B. Most socially-distanced subsequence

题目描述

Given a permutation p of length n, find its subsequence s1, s2, …, sk of length at least 2 such that:
|s1−s2|+|s2−s3|+…+|sk−1−sk| is as big as possible over all subsequences of p with length at least 2.
Among all such subsequences, choose the one whose length, k, is as small as possible.
If multiple subsequences satisfy these conditions, you are allowed to find any of them.
A sequence a is a subsequence of an array b if a can be obtained from b by deleting some (possibly, zero or all) elements.
A permutation of length n is an array of length n in which every element from 1 to n occurs exactly once.

Input

The first line contains an integer t (1≤t≤2⋅104) — the number of test cases. The description of the test cases follows.
The first line of each test case contains an integer n (2≤n≤105) — the length of the permutation p.
The second line of each test case contains n integers p1, p2, …, pn (1≤pi≤n, pi are distinct) — the elements of the permutation p.
The sum of n across the test cases doesn’t exceed 105.

Output

For each test case, the first line should contain the length of the found subsequence, k. The second line should contain s1, s2, …, sk — its elements.
If multiple subsequences satisfy these conditions, you are allowed to find any of them.

Example

input
2
3
3 2 1
4
1 3 4 2
output
2
3 1
3
1 4 2

Note

In the first test case, there are 4 subsequences of length at least 2:
[3,2] which gives us |3−2|=1.
[3,1] which gives us |3−1|=2.
[2,1] which gives us |2−1|=1.
[3,2,1] which gives us |3−2|+|2−1|=2.
So the answer is either [3,1] or [3,2,1]. Since we want the subsequence to be as short as possible, the answer is [3,1].

题目分析

不难发现,当数组中存在连续的3个数且存在单调性时(如:123、321),我们可以删除三个数中间的数,这样得到的结果是一样的。
如:
1 2 3–> |1-2|+|2-3|=2。
删除中间数
1 3 --> |1-3|=2。
还有,如果两个相邻的数是相等的,则也可以删除其中一个。
这样,我们就可以找出a[]中所有的长度在3以上且具有单调性的子串,删除中间的数,只保留两头的两个数。最后剩下的数列即为答案。
这道题的思路很简单,我感觉这道题的难点其实是写代码。。。。

代码如下
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#define LL long long
using namespace std;
const int N=1e5+5;
int a[N];
int main()
{
	int t;
	cin>>t;
	while(t--)
	{
		int n;
		cin>>n;
		vector<int> ans; 	//用vector来储存答案串
		for(int i=0;i<n;i++)
			cin>>a[i];
		
		ans.push_back(a[0]);	//先将最头上的数放入(因为a[]两头的两个数是不可能被删的)
		for(int i=1;i<n-1;i++)	//枚举中间数
		{	//每次取出答案数组中最右边的数与a[i]和a[i+1]进行比较
			if(ans.back()==a[i]) continue;	//如果有两个相邻数相等,则只保留一个(即答案中的那个)
			if(ans.back()<a[i]&&a[i]<=a[i+1]) continue;//判断三个相邻的数是否具有单调性
			if(ans.back()>a[i]&&a[i]>=a[i+1]) continue;//有则跳过中间那个
			ans.push_back(a[i]);	//如果上述条件均不满足则将a[i]放入答案数组
		}
		ans.push_back(a[n-1]);	//最后再将最后一个数放入
		cout<<ans.size()<<endl;
		for(int it:ans) 
		cout<<it<<' ';
		cout<<endl;
	}
	return 0;
}

你可能感兴趣的:(Codeforces)